import { Project } from './project';
import { upload as _upload } from './upload';
import { preview as _preview } from './preview';
import { getDevSourceMap as _getDevSourceMap } from './getDevSourceMap';
import { packNpm, packNpmManually } from '../modules/corecompiler/original/npm/packnpm';
import { setCiProxy as proxy } from '../utils/request';
import { uploadFunction } from './cloud/uploadFunction';
import { createTimeTrigger } from './cloud/createTimeTrigger';
import { uploadContainer } from './cloud/uploadContainer';
import { IUploadOptions } from './cloud/uploadFile';
import { uploadJsServer } from './jsserver';
import { analyseCode } from './code-analyse';
import { getCompiledResult } from './getCompiledResult';
import { getLatestVersion } from './getLatestVersion';
import { getWhiteExtList } from '../utils/white_ext_list';
import { checkCodeQuality } from './checkCodeQuality';
import { buildApk } from './build-apk';
import { buildIpa } from './build-ipa';
import { miniappCloudUpload } from './miniapp-cloud-upload';
export { Project };
export type { IUploadOptions };
export declare const upload: typeof _upload;
export declare const preview: typeof _preview;
export { getCompiledResult };
export { packNpm };
export { packNpmManually };
export { proxy };
export declare const getDevSourceMap: typeof _getDevSourceMap;
export declare const cloud: {
    uploadFunction: typeof uploadFunction;
    createTimeTrigger: typeof createTimeTrigger;
    uploadStaticStorage: (options: IUploadOptions) => Promise<void>;
    uploadStorage: (options: IUploadOptions) => Promise<void>;
    uploadContainer: typeof uploadContainer;
};
export { uploadJsServer };
export { getLatestVersion };
export { analyseCode };
export { checkCodeQuality };
export { getWhiteExtList };
export { buildApk };
export { buildIpa };
export { miniappCloudUpload };
export declare const workletVersion: any;
export declare function cleanCache(): void;
