/// <reference types="node" />
interface ICompileData {
    code: string | Buffer;
    filePath: string;
    root?: string;
    setting?: IMinifySetting;
}
export interface IMinifySetting {
    collapseWhitespace?: boolean;
    conservativeCollapse?: boolean;
    preserveLineBreaks?: boolean;
}
export declare class TemplateTokenizer {
    private tokens?;
    constructor(src: string, path: string);
    toString(): string;
    private generateTokens;
    private m_pSrc;
    private path;
    private machine;
}
export declare class StyleAttrValueTokenizer {
    private tokens?;
    constructor(src: string, path: string);
    toString(): string;
    private generateTokens;
    private m_pSrc;
    private path;
    private machine;
}
export declare function minifyWXML(data: ICompileData): Promise<{
    error: null;
    code: string;
} | {
    error: {
        code: number;
        path: string;
        message: any;
    };
    code?: undefined;
}>;
export {};
