import { MiniProgramSummer } from '../../../types';
import { BaseGraph } from './graph/basegraph';
interface IResolveExt {
    json?: string;
    wxml?: string;
    wxss?: string;
    js?: string;
    wxs?: string;
}
type ResolveValue<T> = T extends Promise<infer K> ? K : T;
type EnsurePromise<T> = Promise<ResolveValue<T>>;
type Arg0<H extends Exclude<keyof MiniProgramSummer.PluginHooks, 'resolveExt'>> = Parameters<MiniProgramSummer.PluginHooks[H]>[0];
export type ReplaceContext = (context: MiniProgramSummer.PluginContext, plugin: MiniProgramSummer.SummerPlugin) => MiniProgramSummer.PluginContext;
export interface ICompilerPlugin extends MiniProgramSummer.PluginHooks {
    resolveExt?: IResolveExt;
}
export declare function genResovleExtConf(plugins: MiniProgramSummer.SummerPlugin[]): {
    json: string[];
    wxml: string[];
    wxss: string[];
    js: string[];
    wxs: string[];
};
export declare function getPluginContext(plugin: MiniProgramSummer.SummerPlugin, graph: BaseGraph): MiniProgramSummer.PluginContext;
export declare class PluginDriver {
    private graph;
    private options;
    resolveExtConf: {
        json: string[];
        wxml: string[];
        wxss: string[];
        js: string[];
        wxs: string[];
    };
    plugins: MiniProgramSummer.SummerPlugin[];
    private pluginContexts;
    constructor(graph: BaseGraph, options: {
        plugins: MiniProgramSummer.SummerPlugin[];
    });
    private runHook;
    hookFirst<H extends MiniProgramSummer.AsyncPluginHooks & MiniProgramSummer.FirstPluginHooks>(hookName: H, args: Parameters<MiniProgramSummer.PluginHooks[H]>, replaceContext?: ReplaceContext | null): EnsurePromise<ReturnType<MiniProgramSummer.PluginHooks[H]>>;
    hookParallel<H extends MiniProgramSummer.AsyncPluginHooks & MiniProgramSummer.ParallelPluginHooks>(hookName: H, args: Parameters<MiniProgramSummer.PluginHooks[H]>, replaceContext?: ReplaceContext): Promise<void>;
    hookReduceArg0<H extends MiniProgramSummer.AsyncPluginHooks & MiniProgramSummer.SequentialPluginHooks>(hookName: H, [arg0, ...rest]: Parameters<MiniProgramSummer.PluginHooks[H]>, reduce: (reduction: Arg0<H>, result: ResolveValue<ReturnType<MiniProgramSummer.PluginHooks[H]>>, plugin: MiniProgramSummer.SummerPlugin) => Arg0<H>, replaceContext?: ReplaceContext | null): Promise<Arg0<H>>;
}
export {};
